;-----------------------------------------------------------------------------------------------
;y Marc Plouhinec (URL: http://www.thebestof.tk email:m_plouhinec@yahoo.fr)
;Small program that explains how to play sound
;A ball is bouncing on the screen, if it hits a side of the screen, a sound is played
;This software is an exemple for SNG programmers
; translated by pacHa
;-----------------------------------------------------------------------------------------------

#include "sngbeta.inc"
 .ORG START_ADDR
 .DB "Example : sound",0

 ROM_CALL(CLEARLCD)      ;Clear the screen


 LD HL,$0100             ;Set coords (1,0)
 LD (CURSOR_POS),HL      ;
 LD A,1                  ;
 LD (avance_lettre_x),A  ;avance_lettre_x = 1 }If avance_lettre_x>0 the ball goes to the right
                         ;                     If avance_lettre_x<0 the ball goes to the left

 LD (avance_lettre_y),A  ;avance_lettre_y = 1 }If avance_lettre_y>0 the ball goes to up
                         ;                     If avance_lettre_y<0 the ball goes to down
boucle:                  ;
 ROM_CALL(CLEARLCD)      ;Clear the screen
 LD HL,(CURSOR_POS)      ;load the coords of the ball into HL
 LD A,$30                ;--|Draw the ball
 ROM_CALL(TX_CHARPUT)    ;--|
 LD (CURSOR_POS),HL      ;
 LD A,(avance_lettre_x)  ;--|
 ADD A,H                 ;  |
 LD H,A                  ;  |Increase or decrease the coords of the ball.
 LD A,(avance_lettre_y)  ;  |
 ADD A,L                 ;  |
 LD L,A                  ;  |
 LD (CURSOR_POS),HL      ;--|

 LD A,H                  ;Has the ball hit the right side ?
 CP 15                   ;
 JR NZ,pasyegual16       ;
 LD A,(avance_lettre_x)  ;--|
 DEC A                   ;  | avance_lettre_x = -1
 DEC A                   ;  |
 LD (avance_lettre_x),A  ;--|
;------------------------
 DI                      ;Play a sound
 PUSH HL                 ;
 ld b, 5                 ;
SON_BOUCLE1:             ;
 LD HL,700               ; HL = ton
 LD DE,100               ; DE = time
 call BEEP               ;
 djnz SON_BOUCLE1        ;
 POP HL                  ;
 EI                      ;
;------------------------
pasyegual16:

 LD A,L                  ;Has the ball hit the bottom of the screen ?
 CP 7                    ;
 JR NZ,pasxegual16       ;
 LD A,(avance_lettre_y)  ;--|
 DEC A                   ;  |avance_lettre_y = -1
 DEC A                   ;  |
 LD (avance_lettre_y),A  ;--|
;------------------------
 DI                      ;Play a sound
 PUSH HL                 ;
 ld b, 5                 ;
SON_BOUCLE2:             ;
 LD HL,500               ; HL = ton
 LD DE,100               ; DE = time
 call BEEP               ;
 djnz SON_BOUCLE2        ;
 POP HL                  ;
 EI                      ;
;------------------------
pasxegual16:

 LD A,H                  ;Has the ball hit the left side ?
 CP 0                    ;
 JR NZ,pasyegual0        ;
 LD A,(avance_lettre_x)  ;--|
 INC A                   ;  |avance_lettre_x = 1
 INC A                   ;  |
 LD (avance_lettre_x),A  ;--|
;------------------------
 DI                      ;Play a sound
 PUSH HL                 ;
 ld b, 5                 ;
SON_BOUCLE3:             ;
 LD HL,900               ; HL = ton
 LD DE,100               ; DE = time
 call BEEP               ;
 djnz SON_BOUCLE3        ;
 POP HL                  ;
 EI                      ;
;------------------------
pasyegual0:

 LD A,L                  ;Has the ball hit the top of the screen ?
 CP 0                    ;
 JR NZ,pasxegual0        ;
 LD A,(avance_lettre_y)  ;--|
 INC A                   ;  |avance_lettre_y = 1
 INC A                   ;  |
 LD (avance_lettre_y),A  ;--|
;------------------------
 DI                      ;Play a sound
 PUSH HL                 ;
 ld b, 5                 ;
SON_BOUCLE4:             ;
 LD HL,200               ; HL = ton
 LD DE,100               ; DE = time
 call BEEP               ;
 djnz SON_BOUCLE4        ;
 POP HL                  ;
 EI                      ;
;------------------------
pasxegual0:

 LD B,$9                 ;
ralenti:                 ;slow down the ball
 HALT                    ;
 DJNZ ralenti            ;

 ld      a,$FF           ;
 out     (1),a           ;
 ld      a,$FD           ;Check for [CLEAR]
 out     (1),a           ;If it's hit, quit the program.
 in      a,(1)           ;
 and     %01000000       ;
 jp      nz,boucle       ;

 RET

avance_lettre_x .DB 0
avance_lettre_y .DB 0
.end
END