;****************************************
;*                 SNG                  *
;*      Shell avec Niveaux de Gris      *
;*                                      *
;*         par Marc Plouhinec           *
;* site: http://thebestof.vze.com       *
;* Email: mailto://m_plouhinec@yahoo.fr *
;*                                      *
;****************************************

#Define SNGFR

#include "sngb.inc"
.END
.ORG $8D4D
; Les appels commencent  partir de l'adresse $8D4D.
; Le shell commence  l'tiquette DEBUT.

;                      |Adresses  appeler:
 jp MUL_HL_BC          ;$8D4D
 jp FILL               ;$8D50
 jp GET_RAND           ;$8D53 RAND = srl a \ GET_RAND
 jp PAUSE              ;$8D56
 jp HL_DECI            ;$8D59
 jp GRB_COPY           ;$8D5C = GRB_COPY
 jp GRB_FILL           ;$8D5F
 jp DIRECT_KEY         ;$8D62
 jp DISP_DELAY         ;$8D65
 jp LINK_SEND          ;$8D68
 jp LINK_GET           ;$8D6B
 jp EXIT_TIOS          ;$8D6E
 jp FIND_INIT          ;$8D71
ROM_CALLS = $+1
 jp $0000 ;$8D74
 jp FIND_NEXT          ;$8D77
 jp KHAND              ;$8D7A
 jp CLR_BUF            ;$8D7D
 jp GRAYSCALE_ON       ;$8D80
 jp GRAYSCALE_OFF      ;$8D83
 jp GRAYSPRITE         ;$8D86
 jp GRAYREMOVE_SPRITE  ;$8D89
 jp GRAYPIC            ;$8D8C
 jp DECOMPRESS_PIC     ;$8D8F
 jp BEEP               ;$8D92
 jp SPRITE             ;$8D95
 jp REMOVE_SPRITE      ;$8D98
 jp CLEAR_TEXT_MEM     ;$8D9B
 jp FILL_TEXT_MEM_SPACE;$8D9E
 jp SUB_HL_BC          ;$8DA1
 jp HL_HEX             ;$8DA4
 jp NEW_INTERUPT       ;$8DA7
 jp STOP_INTERUPT      ;$8DAA

GRB_FILL: ; Remplit GRAPH_MEM avec A
 ld hl,GRAPH_MEM
 ld bc,768
FILL: ; Remplit BC octets avec A, dbute  HL
 ld d,h
 ld e,l
 ld (hl),a
 inc de
 dec bc
 ldir
 ret

DISP_DELAY:
 PUSH AF
 INC HL
 DEC HL
 POP AF
 RET

GET_RAND: ;Donne un nombre entre 0 et 255
 ld a,$A6 ; <--------------------------------------I
 push hl ;                                         I
RAND1: ;                                           I
 ld hl,$8243 ;<------------------------------I     I
 inc l ;                                     I     I
 dec h ;                                     I     I
 add a,(hl) ;                                I     I
 ld (RAND1+1),hl ; Modifie le nombre '$8243'-I     I
 rlca ;                                            I
 rlca ;                                            I
 sub h ;                                           I
 add a,l ;                                         I
 pop hl ;                                          I
 ld (GET_RAND+1),a ; Modifie le nombre '$A6'-------I
 ret

PAUSE: ; Attend la pression de la touche [ENTER]
 ROM_CALL(GET_KEY)
 cp G_ENTER
 ret z
 halt
 jr PAUSE

HL_DECI: ; Convertit le nombre dcimal contenu dans HL en chaine de caractre, HL pointera vers la chaine.
 push de
 ld bc,$0504
 ld de,OP6+5
 xor a
 ld (de),a
HL_DECI1:
 call UNPACK_HL
 add a,48
 dec de
 ld (de),a
 djnz HL_DECI1
 ex de,hl
 pop de
 ld a,48
HL_DECI2:
 cp (hl)
 jr nz,HL_DECI3
 inc hl
 dec c
 jr nz,HL_DECI2
HL_DECI3:
 ld a,4
 sub c
 ret

GRB_COPY:
 push hl
 ld hl,GRAPH_MEM
 push af
 ld a,128
 out ($10),a
 push bc
 push de
 rlca
 or a
 ret z
 dec hl
 ld c,32
 out ($10),a
 inc (hl)
 dec (hl)
 inc hl
 dec hl
 ld de,11
 ld a,c
GRB_COPY1:
 out ($10),a
 inc c
 ld b,64
GRB_COPY2:
 ld a,(hl)
 inc a
 inc hl
 ld a,(hl)
 add hl,de
 out ($11),a
 djnz GRB_COPY2
 dec h
 dec h
 dec h
 inc hl
 ld a,c
 cp 44
 jr nz,GRB_COPY1
 pop de
 pop bc
 pop af
 pop hl
 ret

DIRECT_KEY:
 ld a,$ff
 out (1),a
 dec a
 out (1),a
 in a,(1)
 ld d,a
 ld a,$bf
 out (1),a
 in a,(1)
 or 15
 xor d
 ret

LINK_SEND:
 RET

LINK_GET:
 RET

EXIT_TIOS:
 RET

FIND_INIT:
 ld hl,VAT_START 
 ld (pointeur_VAT),hl
 ret

FIND_NEXT:
 ld hl,(pointeur_VAT)
 ld bc,($8d18)
 inc bc
FIND_NEXT1:
 ld a,(hl)
 dec hl
 ld e,(hl)
 dec hl
 ld d,(hl)
 dec hl
 and $0f
 sbc hl,bc
 ret c
 add hl,bc
 cp 5
 jr z,FIND_NEXT2
 cp 6
 jr z,FIND_NEXT2
 dec hl
 dec hl
 dec hl
 jr FIND_NEXT1
FIND_NEXT2:
 push de
 ld de,OP1
 ld (de),a
 inc de
 ld b,(hl)
 dec hl
FIND_NEXT3:
 ld a,(hl)
 ld (de),a
 dec hl
 inc de
 djnz FIND_NEXT3
 xor a
 ld (de),a
 ld de,(pointeur_VAT)
 ld (pointeur_VAT),hl
 ex de,hl
 pop de
 ret

KHAND:
 RET

CLR_BUF:
 ld hl,APD_BUF3
 ld de,APD_BUF3+1
 ld (hl),0
 ld bc,767
 ldir
 ld hl,GRAPH_MEM
 ld de,GRAPH_MEM+1
 ld (hl),0
 ld bc,767
 ldir
 ret

GRAYSCALE_ON:
 xor a ; reset counter
 ld a,(TEXT_MEM2)
 LD DE,grayint
 CALL NEW_INTERUPT
 ret

GRAYSCALE_OFF:
 LD A,0
 CALL STOP_INTERUPT
 ret

GRAYSPRITE:
;b = x-position, zero is the left edge of LCD
;c = y-position, zero is top line of LCD
;de = this is the address of the first byte of the sprite
;A = this is the height of the sprite (i.e. rows)
 LD (slength),A
 PUSH BC
 PUSH AF
 PUSH DE
 LD HL,GRAPH_MEM
 CALL SPRITE_HL
 POP DE
 POP AF
 POP BC
 LD (slength),A
 LD H,0
 LD L,A
 ADD HL,DE
 EX DE,HL
 LD HL,APD_BUF3
 CALL SPRITE_HL
 RET

GRAYREMOVE_SPRITE:
;b = x-position, zero is the left edge of LCD
;c = y-position, zero is top line of LCD
;de = this is the address of the first byte of the sprite
;A = this is the height of the sprite (i.e. rows)
 LD (slength),A
 PUSH BC
 PUSH AF
 PUSH DE
 LD HL,GRAPH_MEM
 CALL REMOVE_SPRITE_HL
 POP DE
 POP AF
 POP BC
 LD (slength),A
 LD H,0
 LD L,A
 ADD HL,DE
 EX DE,HL
 LD HL,APD_BUF3
 CALL REMOVE_SPRITE_HL
 RET

GRAYPIC:
 RET

DECOMPRESS_PIC:
 RET
;pour les anciennes TI-82
;#define   P_HI      %11000000        ;code to put port high $C0
;#define   P_LO      %11111100        ;code to put port low  $FC
;pour les nouvelles TI-82 (merci  www.paneteti82.fr.st)
#define   P_HI      $C0        ;code to put port high $C0
#define   P_LO      $C3        ;code to put port low  $FC
#define   C_PORT    %00000000        ;addres of com port    $00

;HL = ton
;DE = dure	
BEEP: ;by Eric Linenberg
 push    af
 push    bc
; di      
set_low:
 ld      b,P_LO         
 ld      c,C_PORT      
 out     (c),b          
 push    hl
Delay16bit1:
 dec     hl
 ld      a,l
 or      h
 jr      nz,Delay16bit1
 pop     hl
set_high:
 ld      b,P_HI         
 ld      c,C_PORT       
 out     (c),b          
 push    hl
Delay16bit2:
 dec     hl
 ld      a,l
 or      h
 jr      nz,Delay16bit2
 pop     hl
 dec     de
 ld      a,d
; ei
 pop     bc
 pop     af
 RET

ROM_CALL_aciennes_rom:
 PUSH AF
 LD A,$74
 LD (APD_COUNTER),A
 POP AF
 EX (SP),HL
 LD (ROM_CALLar1),A
 LD A,(HL)
 INC HL
 PUSH BC
 PUSH HL
 PUSH AF
 LD H,(HL)
 LD L,A
 LD BC,$50B
 PUSH HL\ OR A\ SBC HL,BC\ POP HL ;CP HL,BC
 JR C,modif_rien
 POP AF
ROM_CALLar0 = $+1
 ADD A,0 ;ici, on ajoute une valeur pour adapter les appels de la rom 16.0 vers les autres roms.
 POP HL
 POP BC
 LD (ROM_CALLar2),A
 LD A,(HL)
 INC HL
 ADC A,0
 JR cont_ar
modif_rien:
 POP AF
 POP HL
 POP BC
 LD (ROM_CALLar2),A
 LD A,(HL)
 INC HL
cont_ar:
 LD (ROM_CALLar2+1),A
 LD A,0
ROM_CALLar1 = $-1
 EX (SP),HL
ROM_CALLar2 = $+1
 JP $0000

ROM_CALL_nouvelles_rom: ;ROM_CALL(adresse) = CALL $8D74 \ .DW adresse
 PUSH AF
 LD A,$74
 LD (APD_COUNTER),A
 POP AF
 LD (ROM_CALLan1),A  ;On sauve A
 LD (ROM_CALLan3),DE ;On sauve DE
 LD (ROM_CALLan4),BC ;On sauve BC
 LD (ROM_CALLan5),HL ;On sauve HL

 EX (SP),HL ;
 LD E,(HL)  ;
 INC HL     ; Met dans DE l'adresse  appeller
 LD D,(HL)  ;
 INC HL     ;
 EX (SP),HL ;

 LD A,$FF
 LD HL,rom_call_zones-1
 JR modif_appel
modif_appel0:
 EX DE,HL
modif_appel:
 INC A
 INC HL
 LD C,(HL)
 INC HL
 LD B,(HL)

 EX DE,HL
 PUSH HL\ OR A\ SBC HL,BC\ POP HL ;CP HL,BC
 JR NC,modif_appel0
 EX DE,HL

 SLA A
 LD H,0
 LD L,A
 LD BC,rom_call_diff
 ADD HL,BC
 LD A,(HL)
 INC HL
 LD H,(HL)
 LD L,A
 ADD HL,DE
 PUSH HL

 LD BC,0
ROM_CALLan4 = $-2
 LD DE,0
ROM_CALLan3 = $-2
 LD A,0
ROM_CALLan1 = $-1
 LD HL,0
ROM_CALLan5 = $-2
 RET

SPRITE:
;drawsprite:             ;Version 1.2, July 23 1998
 ld hl,$88B8
SPRITE_HL:
 push de
 ld de,12
 inc c
DS_Row:
 dec c
 jr z,DS_Donerow
 add hl,de
 jr DS_Row
DS_Donerow:
 ld a,b
DS_Byte:
 cp 8
 jr c,DS_Donebyte
 sub 8
 inc hl
 jr DS_Byte
DS_Donebyte:
 pop de
 push af
DS_Return:
 pop af
 ex de,hl
 ld b,(hl)
 ld c,0
 push af
DS_Shift:
 or a
 jr z,DS_Doneshift
 dec a
 srl b
 rr c
 jr DS_Shift
DS_Doneshift:
 ex de,hl
 ld a,(hl)
 or b
 ld (hl),a
 inc hl
 ld a,(hl)
 or c
 ld (hl),a
 pop af
 inc de
 push de
 ld de,11
 add hl,de
 pop de
 push af
 ld a,(slength)
 dec a
 ld (slength),a
 CP 0 ;or a
 jr nz,DS_Return
 pop af
 ret

REMOVE_SPRITE:             ;Version 1.2, July 23 1998
 ld hl,$88B8
REMOVE_SPRITE_HL:
 push de
 ld de,12
 inc c
RS_Row:
 dec c
 jr z,RS_Donerow
 add hl,de
 jr RS_Row
RS_Donerow:
 ld a,b
RS_Byte:
 cp 8
 jr c,RS_Donebyte
 sub 8
 inc hl
 jr RS_Byte
RS_Donebyte:
 pop de
 push af
RS_Return:
 pop af
 ex de,hl
 ld b,(hl)
 ld c,0
 push af
RS_Shift:
 or a
 jr z,RS_Doneshift
 dec a
 srl b
 rr c
 jr RS_Shift
RS_Doneshift:
 ex de,hl
 ld a,b
 cpl
 and (hl)
 ld (hl),a
 inc hl
 ld a,c
 cpl
 and (hl)
 ld (hl),a
 pop af
 inc de
 push de
 ld de,11
 add hl,de
 pop de
 push af
 ld a,(slength)
 dec a
 ld (slength),a
 or a
 jr nz,RS_Return
 pop af
 RET

MUL_HL_BC: ;HL=HL*BC
 PUSH DE
 LD D,H
 LD E,L
boucle_mul:
 DEC BC
 PUSH HL\ LD HL,0\ OR A\ SBC HL,BC\ POP HL ;CP BC,0
 JR Z,fin_boucle_mul
 ADD HL,DE
 JR boucle_mul
fin_boucle_mul:
 POP DE
 RET

CLEAR_TEXT_MEM:
 PUSH HL
 PUSH DE
 PUSH BC
 LD HL,TEXT_MEM
 LD DE,TEXT_MEM+1
 LD (HL),0
 LD BC,127
 LDIR
 POP HL
 POP DE
 POP BC
 RET

FILL_TEXT_MEM_SPACE:
 PUSH HL
 PUSH DE
 PUSH BC
 LD HL,TEXT_MEM
 LD DE,TEXT_MEM+1
 LD (HL),$20
 LD BC,127
 LDIR
 POP HL
 POP DE
 POP BC
 RET

SUB_HL_BC:
 PUSH DE
 LD D,0
 ADD A,D
 LD D,B
 LD E,C
 SBC HL,DE
 POP DE
 RET

HL_HEX:
 ld a,h
 and $0f0
 rrca
 rrca
 rrca
 rrca
 add a,$30
 cp $3a
 jr c,HL_HEX0
 add a, $7
HL_HEX0:
 ld (OP1),a
 ld a,h
 and $0f
 add a,$30
 cp $3a
 jr c,HL_HEX1
 add a, $7
HL_HEX1:
 ld (OP1+1),a
 ld a,l
 and $0f0
 rrca
 rrca
 rrca
 rrca
 add a,$30
 cp $3a
 jr c,HL_HEX2
 add a, $7
HL_HEX2:
 ld (OP1+2),a
 ld a,l
 and $0f
 add a,$30
 cp $3a
 jr c,HL_HEX3
 add a, $7
HL_HEX3:
 ld (OP1+3),a
 xor a
 ld (OP1+4),a
 ld hl,OP1
 RET

enter_listprog:
 LD HL,TEXT_MEM   ;
 LD DE,TEXT_MEM+1 ;
 LD (HL),0         ;Vide TEXT_MEM
 LD BC,127         ;
 LDIR              ;
 LD HL,TEXT_MEM
 LD (pointeur_TEXT_MEM),HL
 LD HL,$FD9D
 LD B,0
 LD C,0
cherche_prog:
 LD A,(HL)
 CP 6
 CALL Z,prog_trouv
 LD A,($8D19) ;La fin de la VAT est indique  l'adresse $8D18
 CP H
 JR NZ,c_pas_la_fin_de_la_vat
 LD A,($8D18)
 CP L
 JR Z,cherche_prog_fin
c_pas_la_fin_de_la_vat:
 DEC HL
 JR cherche_prog
cherche_prog_fin:
 LD A,B
 CP 0
 JR NZ,il_y_a_des_prog
 LD HL,0
 LD (CURSOR_POS),HL
 LD HL,pas_prog
 ROM_CALL(D_ZT_STR)
 CALL PAUSE
fin4:
 jp retourne_menu
il_y_a_des_prog:
 DEC C
 CALL GRAYSCALE_ON
 LD B,0
 PUSH BC
 LD HL,0
 LD L,B
 LD BC,12
 CALL MUL_HL_BC
 LD D,H
 LD E,L
 LD HL,GRAPH_MEM
 ADD HL,DE
 LD DE,APD_BUF3
 LD BC,72
 LDIR
 POP BC
attend_touche5:

 PUSH BC
 POP BC

 ld a,$FF
 out (1),a
 ld a,%10111111
 out (1),a
 in a,(1)
 and %01000000
 jp z,retourne_menu

 ld a,%11111110
 out (1),a
 in a,(1)
 and %00001000
 call z,haut_prog

 ld a,%11111110
 out (1),a
 in a,(1)
 and %00000001
 call z,bas_prog

 ld a,$FF
 out (1),a
 ld a,%11111101
 out (1),a
 in a,(1)
 and %00000001
 jp z,exec_prog

 jr attend_touche5

haut_prog:
 in a,(1)
 and %00001000
 JR z,haut_prog
 LD A,B
 CP 0
 RET Z
 LD A,B
 SUB 1
 LD B,A
 PUSH BC
 LD A,B
 ADD A,1
 LD B,A
 LD HL,0
 LD L,B
 LD BC,6
 CALL MUL_HL_BC
 LD BC,12
 CALL MUL_HL_BC
 LD B,H
 LD C,L
 LD HL,APD_BUF3
 ADD HL,BC
 LD (HL),0
 LD DE,APD_BUF3+1
 PUSH HL
 LD H,D
 LD L,E
 ADD HL,BC
 LD D,H
 LD E,L
 POP HL
 LD BC,71
 LDIR
 POP BC
 PUSH BC
 LD HL,0
 LD L,B
 LD BC,6
 CALL MUL_HL_BC
 LD BC,12
 CALL MUL_HL_BC
 LD B,H
 LD C,L
 LD HL,GRAPH_MEM
 ADD HL,BC
 LD DE,APD_BUF3
 PUSH HL
 LD H,D
 LD L,E
 ADD HL,BC
 LD D,H
 LD E,L
 POP HL
 LD BC,72
 LDIR
 POP BC
 RET

bas_prog:
 in a,(1)
 and %00000001
 JR z,bas_prog
 LD A,B
 CP C
 RET Z
 LD A,B
 ADD A,1
 LD B,A
 PUSH BC
 LD A,B
 SUB 1
 LD B,A
 LD HL,0
 LD L,B
 LD BC,6
 CALL MUL_HL_BC
 LD BC,12
 CALL MUL_HL_BC
 LD B,H
 LD C,L
 LD HL,APD_BUF3
 ADD HL,BC
 LD (HL),0
 LD DE,APD_BUF3+1
 PUSH HL
 LD H,D
 LD L,E
 ADD HL,BC
 LD D,H
 LD E,L
 POP HL
 LD BC,71
 LDIR
 POP BC
 PUSH BC
 LD HL,0
 LD L,B
 LD BC,6
 CALL MUL_HL_BC
 LD BC,12
 CALL MUL_HL_BC
 LD B,H
 LD C,L
 LD HL,GRAPH_MEM
 ADD HL,BC
 LD DE,APD_BUF3
 PUSH HL
 LD H,D
 LD L,E
 ADD HL,BC
 LD D,H
 LD E,L
 POP HL
 LD BC,72
 LDIR
 POP BC
 RET
retourne_menu:
 CALL GRAYSCALE_OFF
 RET

prog_trouv:
;Ici, on n'est pas sr si c'est un programme.
;Cette routine va vrifier le fichier: au dbut d'un programme pour SNG, il y a les lettres 'SNG'.
 PUSH HL
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 INC DE
 INC DE
 LD A,(DE)
 CP $53 ;S
 JR NZ,pas_de_prog
 INC DE
 LD A,(DE)
 CP $4E ;N
 JR NZ,pas_de_prog
 INC DE
 LD A,(DE)
 CP $47 ;G
 JR NZ,pas_de_prog
 POP HL
 JR il_y_a_prog
pas_de_prog:
 POP HL
 RET
il_y_a_prog: ;Ici, on est sr que c'est un programme.
 PUSH HL                    ;
 PUSH DE                    ;
 EX DE,HL                   ;
 LD HL,(pointeur_TEXT_MEM) ;
 LD (HL),D                  ;Ici, on enregistre dans TEXT_MEM les adresses des programmes.
 INC HL                     ;
 LD (HL),E                  ;
 INC HL                     ;
 LD (pointeur_TEXT_MEM),HL ;
 POP DE                     ;
 POP HL                     ;
 INC C
 SET 7,(IY+$14)
 PUSH HL
 LD D,B
 LD E,0
 LD (GRAF_CURS),DE
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 LD H,D
 LD L,E
 INC HL
 INC HL
 INC HL
 INC HL
 INC HL
 ROM_CALL(D_ZM_STR)
 POP HL
 LD A,B
 ADD A,6
 LD B,A
 RET

exec_prog:
 PUSH HL
 PUSH BC

 LD A,B  ;B = numro du programme
 ADD A,A ;A = A*2
 LD HL,0
 LD L,A
 LD BC,TEXT_MEM
 ADD HL,BC
 LD D,(HL)
 INC HL
 LD E,(HL)
 EX DE,HL
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 EX DE,HL
;HL = Zone o est enregistr le prog
 PUSH HL
 CALL Deplace_prog

;cherche l o dbute prog
 LD HL,DEBUT_PROG2
cherche_la_ou_debute_prog:
 LD A,(HL)
 CP 0
 JR Z,trouve_la_ou_debute_prog
 INC HL
 JR cherche_la_ou_debute_prog
trouve_la_ou_debute_prog:

 PUSH HL
 call GRAYSCALE_OFF
 CALL CLR_BUF
 CALL CLEAR_TEXT_MEM
 RES 7,(IY+$14)
 RES 1,(IY+$0D)
 POP HL

;HL = Zone o est execut le prog
 LD (Appel_prog+1),HL
 LD HL,OP1
 LD BC,$37
 LD A,0
 CALL FILL
 LD A,0
 LD BC,0
 LD HL,0
 LD DE,0

Appel_prog:
 CALL $0000
 call attend_aucune_touche
; call GRAYSCALE_ON
 SET 1,(IY+$0D)
 SET 7,(IY+$14)
 RES 3,(IY+$05)
;HL = Zone o est enregistr le prog
 POP HL
 CALL Replace_prog

 CALL CLR_BUF

 POP BC
 POP HL
 JP enter_listprog

;HL = Zone o est enregistr le prog

Deplace_prog:
;On dcale le programme

 LD (deplace_prog_var),HL
 LD C,(HL)
 INC HL
 LD B,(HL)
 INC BC
 INC BC
 LD HL,768
 LD (deplace_prog_var2),HL

recommence_deplace_prog:

;On teste si on est pas trop prs de DEBUT_PROG pour dcaler de 768 octets
 PUSH BC
 LD HL,(deplace_prog_var)
 LD BC,DEBUT_PROG
 CALL SUB_HL_BC
 LD DE,768
 CALL CP_HL_DE
 JR NC,continue_deplace_prog
 LD (deplace_prog_var2),HL
 LD (deplace_prog_var4),HL
continue_deplace_prog:
 POP BC

;On enregistre les 768 octets qui peuvent tre crass par le programme.
 PUSH BC
 LD HL,(deplace_prog_var)
 LD BC,(deplace_prog_var2)
 CALL SUB_HL_BC
 LD DE,GRAPH_MEM
 LD BC,(deplace_prog_var2)
 LDIR
 POP BC

;On dcale le programme de 768 octets
 LD HL,(deplace_prog_var)
 PUSH BC
 PUSH HL
 LD BC,(deplace_prog_var2)
 CALL SUB_HL_BC
 LD (deplace_prog_var),HL
 EX DE,HL
 POP HL
 POP BC
 PUSH BC
 LDIR
 POP BC

;On rcrit les octets sauvegards l o tait enregistr le programme.
 LD HL,(deplace_prog_var)
 ADD HL,BC
 EX DE,HL
 LD HL,GRAPH_MEM
 PUSH BC
 LD BC,(deplace_prog_var2)
 LDIR
 POP BC

;Teste si on doit quitter la routine
 LD HL,(deplace_prog_var2)
 LD DE,768
 CALL CP_HL_DE
 JP Z,recommence_deplace_prog

 RET

;HL = Zone o tait enregistr le prog

Replace_prog:
;On dcale le programme
 LD (deplace_prog_var),HL
 LD HL,DEBUT_PROG
 LD C,(HL)
 INC HL
 LD B,(HL)
 INC BC
 INC BC
 LD (deplace_prog_var2),BC
 LD HL,DEBUT_PROG
 LD (deplace_prog_var3),HL

;calcule le nombre d'octets  dplacer en premier
 LD HL,(deplace_prog_var4)
 LD (deplace_prog_var2),HL

recommence_replace_prog:

;On sauve une partie des octets qui ont faillit se faire craser
 LD HL,(deplace_prog_var3)
 ADD HL,BC
 LD DE,GRAPH_MEM
 PUSH BC
 LD BC,(deplace_prog_var2)
 LDIR
 POP BC

;On dcale le programme
 PUSH BC
 LD HL,(deplace_prog_var3)
 LD DE,(deplace_prog_var2)
 ADD HL,DE
 ADD HL,BC
 EX DE,HL
 LD HL,(deplace_prog_var3)
 ADD HL,BC
 DEC HL
 DEC DE
 LDDR
 POP BC

;On restore les octest dplacs
 LD DE,(deplace_prog_var3)
 LD HL,GRAPH_MEM
 PUSH BC
 LD BC,(deplace_prog_var2)
 LDIR
 POP BC

 LD HL,(deplace_prog_var3)
 LD DE,(deplace_prog_var2)
 ADD HL,DE
 LD (deplace_prog_var3),HL

 LD HL,768
 LD (deplace_prog_var2),HL

 LD HL,(deplace_prog_var3)
 LD DE,(deplace_prog_var)
 CALL CP_HL_DE
 JP NZ,recommence_replace_prog

 RET

grayint:
; ex      af,af'
; exx
; in      a,(3) ; check vbl int
; and     %00000010
; jr      z,exit_interrupt
 ld      hl,TEXT_MEM2 ; inc counter
 inc     (hl)
 ld      a,(hl)
 dec     a ; 1
 jr      z,dpic2
 dec     a ; 2
 jr      z,dpic1
 ld      (hl),0 ; reset counter

 RET
;exit_interrupt:
; in      a,(3) ; check on interrupt status
; rra
; ld      a,0
; adc     a,9
; out     (3),a
; ld      a,$0B
; out     (3),a
; exx
; ex      af,af'
; ei
; reti
; jp      $0038

dpic1:
 ld hl,APD_BUF3
 jr drawp
dpic2:
 ld hl,GRAPH_MEM
drawp:
 ld a,$80
 out ($10),a
 ld de,755
 add hl,de
 ld a,$20
 ld c,a
wloop1:
 ld b,64
 inc c
 ld de,-767
 out ($10),a
 add hl,de
 ld de,11
wloop2:
 add hl,de
 inc hl
 ld a,(hl)
 out ($11),a
 push ix
 pop ix
 djnz wloop2
 ld a,c
 cp $2B+1
 jr nz,wloop1

 RET
; jr exit_interrupt

TABLE8 = $84
TABLE = TABLE8*$100
CODE8 = TABLE8-2
CODE = TABLE-$17E

NEW_INTERUPT: ;DE=adresse de l'interuption
 PUSH AF
 PUSH BC
 PUSH HL
 PUSH DE
 LD A,(APD_BUF) ; APD_BUF = nombre d'interruptions
 CP 0
 JR NZ,rajoute_int
 INC A
 LD (APD_BUF),A
 ld hl,TABLE
 ld de,TABLE+1
 ld (hl),CODE8
 ld bc,$0100
 ldir
 ld hl,CODE

 ld (hl),$08
 inc hl
 ld (hl),$D9
 inc hl
 ld (hl),$DB
 inc hl
 ld (hl),$03
 inc hl
 ld (hl),$E6
 inc hl
 ld (hl),$02
 inc hl
 ld (hl),$20
 inc hl
 ld (hl),$12
 inc hl
 ld (hl),$DB
 inc hl
 ld (hl),$03
 inc hl
 ld (hl),$1F
 inc hl
 ld (hl),$3E
 inc hl
 ld (hl),$00
 inc hl
 ld (hl),$CE
 inc hl
 ld (hl),$09
 inc hl
 ld (hl),$D3
 inc hl
 ld (hl),$03
 inc hl
 ld (hl),$3E
 inc hl
 ld (hl),$0B
 inc hl
 ld (hl),$D3
 inc hl
 ld (hl),$03
 inc hl
 ld (hl),$D9
 inc hl
 ld (hl),$08
 inc hl
 ld (hl),$FB
 inc hl
 ld (hl),$ED
 inc hl
 ld (hl),$4D
 inc hl

;
; ex      af,af'
; exx
; in      a,(3) ; check vbl int
; and     %00000010
; jr      nz,exec_interrupt
; in      a,(3) ; check on interrupt status
; rra
; ld      a,0
; adc     a,9
; out     (3),a
; ld      a,$0B
; out     (3),a
; exx
; ex      af,af'
;exec_interrupt:
; ei
; reti
 JR ajoute_code
rajoute_int:
 INC A
 LD (APD_BUF),A
 DEC A
 LD H,0
 LD L,A
 LD BC,3
 CALL MUL_HL_BC
 LD BC,CODE+$1A
 ADD HL,BC
ajoute_code:
 POP DE
 PUSH DE
 ld (hl),$CD ;=call
 inc hl
 ld (hl),E
 inc hl
 ld (hl),D
 inc hl
 ld (hl),$DB
 inc hl
 ld (hl),$03
 inc hl
 ld (hl),$1F
 inc hl
 ld (hl),$3E
 inc hl
 ld (hl),$00
 inc hl
 ld (hl),$CE
 inc hl
 ld (hl),$09
 inc hl
 ld (hl),$D3
 inc hl
 ld (hl),$03
 inc hl
 ld (hl),$3E
 inc hl
 ld (hl),$0B
 inc hl
 ld (hl),$D3
 inc hl
 ld (hl),$03
 inc hl
 ld (hl),$D9
 inc hl
 ld (hl),$08
 inc hl
 ld (hl),$FB
 inc hl
 ld (hl),$ED
 inc hl
 ld (hl),$4D
 ld a,TABLE8
 ld i,a
 im 2
 POP DE
 POP HL
 POP BC
 POP AF
 ret

STOP_INTERUPT: ;A=numero de l'instruction
 LD H,0
 LD L,A
 LD A,(APD_BUF)
 DEC A
 LD (APD_BUF),A
 CP 0
 JR Z,arrete_interrupt
 LD BC,3
 CALL MUL_HL_BC
 LD BC,CODE+$1A
 ADD HL,BC

 LD D,H
 LD E,L
 INC HL
 INC HL
 DEC DE
ecrase_appel:
 INC HL
 INC DE
 LD A,(HL)
 LD (DE),A
 CP $4D
 JR Z,teste_arret_ecrase_appel
 LD C,B
 LD B,A
 JR ecrase_appel
teste_arret_ecrase_appel:
 LD HL,$EDFB
 CP_HL_BC
 JR NZ,ecrase_appel
 ret
arrete_interrupt:
 im 1
 ret



rom_call_diff:
 .DW 0
 .DW 0
 .DW $1F
 .DW $51
 .DW $52
 .DW $53
 .DW $9B
 .DW $46
 .DW $57
 .DW $221
 .DW $53
 .DW $FFCE ;-32
 .DW $43
 .DW $47
 .DW $12B
 .DW $12C
 .DW $12E
 .DW $12F
 .DW $13F
 .DW $142
 .DW $145
 .DW $143
 .DW $144
 .DW $160
 .DW $166
 .DW $13C
 .DW $15D
 .DW $157
 .DW $14B
 .DW $145
 .DW $13F
 .DW $139
 .DW $133
 .DW $13F
 .DW $127
 .DW $133
 .DW $157
 .DW $163
 .DW $163

rom_call_zones:
 .DW $0008
 .DW $0103
 .DW $021d
 .DW $0272
 .DW $027E
 .DW $059D
 .DW $05AD
 .DW $05F2
 .DW $061E
 .DW $0625
 .DW $066A
 .DW $067A
 .DW $0684
 .DW $07F8
 .DW $0A0D
 .DW $0FCE
 .DW $0FD0
 .DW $0FD5
 .DW $0FF9
 .DW $1005
 .DW $29D6
 .DW $2E1C
 .DW $2E22
 .DW $2E37
 .DW $2E3C
 .DW $2E46
 .DW $31E1
 .DW $3249
 .DW $32DF
 .DW $37B3
 .DW $37C5
 .DW $3878
 .DW $38BB
 .DW $38C7
 .DW $38D3
 .DW $390F
 .DW $3927
 .DW $4000

;Variables:

curseur_list_var .DB 0
mem_free .DW 0
numero_fichier .DB 0
endroit_liste_var .DW 0
endroit_liste_var2 .DB 0
endroit_liste_var3 .DB 0
pointeur_VAT .DW 0
sprite_triangle .DB 0
pointeur_TEXT_MEM .DW 0
deplace_prog_var .DW 0
deplace_prog_var2 .DW 0
deplace_prog_var3 .DW 0
deplace_prog_var4 .DW 0
slength .DB 0

.ORG $9600
APD_BUF3:

.ORG $9900
DEBUT: ;--------------------------------------------------------------------------------------------------------------------
 LD (restaure_sp+1),sp
 LD HL,$1B41   ;Pour cracker la TI-82, une zone de la RAM a t modifie,
 LD ($8114),HL ;elle est restaure ici.
 CALL Adapte_ROM_CALL
 ROM_CALL(BUSY_OFF) ;enlve l'indicateur en haut  droite de l'cran.
 call contre_l_ecran_qui_sautille
 LD A,0
 LD (APD_BUF),A ;Initialise le compteur des interuptions

;contre la calculette qui s'teint toute seule
; set 3,(iy+$12)
; res 4,(iy+$09)
; ld a,$16
; out ($04),a
; set 0,(iy+$03)
; res 3,(iy+$05)
; ld hl,_IY_TABLE+12 ;$8534
; res 2,(hl)
; inc hl
; set 1,(hl)
; set 2,(hl)
; ld a,$05
; out ($10),a
; res 0,(iy+$12)
; res 7,(iy+$14)

 call CLR_BUF
 LD A,0
 LD (sprite_triangle),A
 call affiche_menu
 call affiche_sprite_triangle
 call GRAYSCALE_ON
 LD C,15
 call attend
attend_touche:

 ld a,$FF
 out (1),a
 ld a,%10111111
 out (1),a
 in a,(1)
 and %01000000
 jp z,quit

 ld a,%11111110
 out (1),a
 in a,(1)
 and %00001000
 call z,haut

 ld a,%11111110
 out (1),a
 in a,(1)
 and %00000001
 call z,bas

 ld a,$FF
 out (1),a
 ld a,%11111101
 out (1),a
 in a,(1)
 and %00000001
 call z,enter

 jr attend_touche

;Appels de SNG

enter:
 LD C,15
 call attend
 call CLR_BUF
 ROM_CALL(CLEARLCD)
 call GRAYSCALE_OFF
 LD A,(sprite_triangle)
 CP 0
 CALL Z,enter_listprog
 CP 1
 CALL Z,enter_listvar
 CP 2
 CALL Z,enter_edithexa
 CP 3
 CALL Z,enter_debug
 CP 4
 CALL Z,enter_apropos
 call CLR_BUF
 call affiche_menu
 call affiche_sprite_triangle
 call GRAYSCALE_ON
 LD C,15
 call attend
 RET

haut:
 IN A,(1)
 AND %00001000
 JR Z,haut
 call efface_sprite_triangle
 LD A,(sprite_triangle)
 CP 0
 JR Z,trophaut
 DEC A
 JR haut1
trophaut:
 LD A,4
haut1:
 LD (sprite_triangle),A
 call affiche_sprite_triangle
 ret

bas:
 IN A,(1)
 AND %00000001
 JR Z,bas
 call attend_aucune_touche
 call efface_sprite_triangle
 LD A,(sprite_triangle)
 CP 4
 JR Z,tropbas
 INC A
 JR bas1
tropbas:
 LD A,0
bas1:
 LD (sprite_triangle),A
 call affiche_sprite_triangle
 ret

;---------------------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------------------
enter_listvar:
 RET

enter_edithexa:
 LD HL,VAT_START
 LD DE,(VAT_END)
 LD BC,0
cherche_prog_SNGedit:
 DEC HL
 LD A,(HL)
 CP 6
 CALL Z,Estce_SNGedit
 CALL CP_HL_DE
 JR NZ,cherche_prog_SNGedit
 LD A,B
 CP 0
 JR NZ,SNGedit_existe
 LD HL,0
 LD (CURSOR_POS),HL
 LD HL,ch_pas_edit_hex
 ROM_CALL(D_ZT_STR)
 CALL PAUSE
 RET

Estce_SNGedit:
 PUSH DE
 PUSH HL
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 EX DE,HL
 INC HL
 INC HL
 LD A,(HL)
 CP $53 ;"S"
 JR NZ,c_pas_SNGedit
 INC HL
 LD A,(HL)
 CP $65 ;"e"
 JR NZ,c_pas_SNGedit
 INC HL
 LD A,(HL)
 CP $64 ;"d"
 POP HL
 LD B,H
 LD C,L
 POP DE
 RET
c_pas_SNGedit:
 POP HL
 POP DE
 RET

SNGedit_existe:
 LD H,B
 LD L,C
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 EX DE,HL
 PUSH HL
;HL = Zone o est enregistr le prog
 CALL Deplace_prog
 CALL DEBUT_PROG2 ;Saute vers le programme SNGedit
 POP HL
 CALL Replace_prog
 RET

enter_debug:
 LD HL,VAT_START
 LD DE,(VAT_END)
 LD BC,0
cherche_prog_SNGdeb:
 DEC HL
 LD A,(HL)
 CP 6
 CALL Z,Estce_SNGdeb
 CALL CP_HL_DE
 JR NZ,cherche_prog_SNGdeb
 LD A,B
 CP 0
 JR NZ,SNGdeb_existe
 LD HL,0
 LD (CURSOR_POS),HL
 LD HL,ch_pas_debug
 ROM_CALL(D_ZT_STR)
 CALL PAUSE
 RET

Estce_SNGdeb:
 PUSH DE
 PUSH HL
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 EX DE,HL
 INC HL
 INC HL
 LD A,(HL)
 CP $53 ;"S"
 JR NZ,c_pas_SNGdeb
 INC HL
 LD A,(HL)
 CP $64 ;"d"
 JR NZ,c_pas_SNGdeb
 INC HL
 LD A,(HL)
 CP $65 ;"e"
 POP HL
 LD B,H
 LD C,L
 POP DE
 RET
c_pas_SNGdeb:
 POP HL
 POP DE
 RET

SNGdeb_existe:
 LD H,B
 LD L,C
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 EX DE,HL
 PUSH HL
;HL = Zone o est enregistr le prog
 CALL Deplace_prog
 CALL DEBUT_PROG2 ;Saute vers le programme SNGdeb
 POP HL
 CALL Replace_prog
 RET

enter_apropos:
 RES 7,(IY+$14)
 LD HL,0
 LD (CURSOR_POS),HL
 LD HL,apropos_ch
 ROM_CALL(D_ZT_STR)
 LD HL,$3000
 LD (GRAF_CURS),HL
 LD HL,apropos_ch2
 ROM_CALL(D_ZM_STR)
 call PAUSE
 RET


Adapte_ROM_CALL:
 LD A,($29D0) ;pour rom |16.0:36| |17.0:37| |18.0:38| |19.0:6D| |19.006:18|
 CP $36
 JR Z,anc_rom
 CP $37
 JR Z,anc_rom
 CP $38
 JR Z,anc_rom
 CP $6D
 JR Z,anc_rom2
 CP $18
 JR Z,nouv_rom
anc_rom:
 LD A,0
 LD (ROM_CALLar0),A
 LD HL,ROM_CALL_aciennes_rom
 JR adapte_rom_cont
anc_rom2:
 LD A,$1A
 LD (ROM_CALLar0),A
 LD HL,ROM_CALL_aciennes_rom
 JR adapte_rom_cont
nouv_rom:
 LD HL,ROM_CALL_nouvelles_rom
adapte_rom_cont:
 LD (ROM_CALLS),HL
 RET

affiche_sprite_triangle:

 LD A,(sprite_triangle)
 CP 0
 JR NZ,p_spr_pos_0
 LD BC,COORD_TRI_11
p_spr_pos_0
 CP 1
 JR NZ,p_spr_pos_1
 LD BC,COORD_TRI_12
p_spr_pos_1
 CP 2
 JR NZ,p_spr_pos_2
 LD BC,COORD_TRI_13
p_spr_pos_2
 CP 3
 JR NZ,p_spr_pos_3
 LD BC,COORD_TRI_14
p_spr_pos_3
 CP 4
 JR NZ,p_spr_pos_4
 LD BC,COORD_TRI_15
p_spr_pos_4

 LD DE,sprite_triangle1
 LD A,8
 call GRAYSPRITE

 LD A,(sprite_triangle)
 CP 0
 JR NZ,p_spr_pos_02
 LD BC,COORD_TRI_21
p_spr_pos_02
 CP 1
 JR NZ,p_spr_pos_12
 LD BC,COORD_TRI_22
p_spr_pos_12
 CP 2
 JR NZ,p_spr_pos_22
 LD BC,COORD_TRI_23
p_spr_pos_22
 CP 3
 JR NZ,p_spr_pos_32
 LD BC,COORD_TRI_24
p_spr_pos_32
 CP 4
 JR NZ,p_spr_pos_42
 LD BC,COORD_TRI_25
p_spr_pos_42

 LD DE,sprite_triangle2
 LD A,8
 call GRAYSPRITE

 RET

efface_sprite_triangle:
 LD A,(sprite_triangle)
 CP 0
 JR NZ,p_spr_pos_03
 LD BC,COORD_TRI_11
p_spr_pos_03
 CP 1
 JR NZ,p_spr_pos_13
 LD BC,COORD_TRI_12
p_spr_pos_13
 CP 2
 JR NZ,p_spr_pos_23
 LD BC,COORD_TRI_13
p_spr_pos_23
 CP 3
 JR NZ,p_spr_pos_33
 LD BC,COORD_TRI_14
p_spr_pos_33
 CP 4
 JR NZ,p_spr_pos_43
 LD BC,COORD_TRI_15
p_spr_pos_43

 LD DE,sprite_triangle1
 LD A,8
 LD (slength),A
 LD HL,APD_BUF3
 call REMOVE_SPRITE_HL

 LD A,(sprite_triangle)
 CP 0
 JR NZ,p_spr_pos_023
 LD BC,COORD_TRI_21
p_spr_pos_023
 CP 1
 JR NZ,p_spr_pos_123
 LD BC,COORD_TRI_22
p_spr_pos_123
 CP 2
 JR NZ,p_spr_pos_223
 LD BC,COORD_TRI_23
p_spr_pos_223
 CP 3
 JR NZ,p_spr_pos_323
 LD BC,COORD_TRI_24
p_spr_pos_323
 CP 4
 JR NZ,p_spr_pos_423
 LD BC,COORD_TRI_25
p_spr_pos_423

 LD DE,sprite_triangle2
 LD A,8
 LD (slength),A
 LD HL,APD_BUF3
 call REMOVE_SPRITE_HL
 RET

affiche_menu:
 LD HL,sng_img
 LD DE,GRAPH_MEM+36
 LD BC,168
 LDIR
;Affiche un rectangle aux coordonnes (5,19)(90,19)(5,61)(90,61)
 LD A,%00000111
 LD (GRAPH_MEM+228),A
 LD (GRAPH_MEM+732),A
 LD A,%11100000
 LD (GRAPH_MEM+239),A
 LD (GRAPH_MEM+743),A

 LD HL,GRAPH_MEM+240
 LD DE,12
rect_ligne1:
 LD (HL),%00000100
 ADD HL,DE
 LD A,H
 CP $8B
 JR NZ,rect_ligne1
 LD A,L
 CP $94
 JR NZ,rect_ligne1

 LD HL,GRAPH_MEM+251
 LD DE,12
rect_ligne2:
 LD (HL),%00100000
 ADD HL,DE
 LD A,H
 CP $8B
 JR NZ,rect_ligne2
 LD A,L
 CP $9F
 JR NZ,rect_ligne2

 LD A,$FF
 LD (GRAPH_MEM+229),A
 LD HL,GRAPH_MEM+229
 LD DE,GRAPH_MEM+230
 LD BC,9
 LDIR

 LD A,$FF
 LD (GRAPH_MEM+733),A
 LD HL,GRAPH_MEM+733
 LD DE,GRAPH_MEM+734
 LD BC,9
 LDIR

;Affiche les chaines de caractres
 SET 7,(IY+$14)
 LD HL,COORD_TEXT_1
 LD (GRAF_CURS),HL
 LD HL,listprog
 ROM_CALL(D_ZM_STR)
 LD HL,COORD_TEXT_2
 LD (GRAF_CURS),HL
 LD HL,listvar
 ROM_CALL(D_ZM_STR)
 LD HL,COORD_TEXT_3
 LD (GRAF_CURS),HL
 LD HL,edithexa
 ROM_CALL(D_ZM_STR)
 LD HL,COORD_TEXT_4
 LD (GRAF_CURS),HL
 LD HL,debug
 ROM_CALL(D_ZM_STR)
 LD HL,COORD_TEXT_5
 LD (GRAF_CURS),HL
 LD HL,apropos
 ROM_CALL(D_ZM_STR)
 RES 7,(IY+$14)

;Recopie GRAPH_MEM (buffer du gris clair) dans APD_BUF3
 LD HL,GRAPH_MEM
 LD DE,APD_BUF3
 LD BC,768
 LDIR

;Trace un rectangle plein en gris clair aux coordonnes (5,19)(90,19)(5,61)(90,61)
 LD A,$FF
 LD (GRAPH_MEM+228),A
 LD HL,GRAPH_MEM+228
 LD DE,GRAPH_MEM+229
 LD BC,504
 LDIR

 LD HL,GRAPH_MEM+228
 LD DE,12
rect_ligne3:
 LD (HL),%00000111
 ADD HL,DE
 LD A,H
 CP $8B
 JR NZ,rect_ligne3
 LD A,L
 CP $A0
 JR NZ,rect_ligne3

 LD HL,GRAPH_MEM+239
 LD DE,12
rect_ligne4:
 LD (HL),%11100000
 ADD HL,DE
 LD A,H
 CP $8B
 JR NZ,rect_ligne4
 LD A,L
 CP $9F
 JR NZ,rect_ligne4
 RET

contre_l_ecran_qui_sautille:
 ld a,$16
 out ($04),a
 set 0,(iy+$03)
 res 3,(iy+$05)
 ld hl,_IY_TABLE+12 ;$8534
 res 2,(hl)
 inc hl
 set 1,(hl)
 set 2,(hl)
 ld a,$05
 out ($10),a
 res 0,(iy+$12)
 res 7,(iy+$14)
 ret

quit:
 im 1
 call CLR_BUF
 ROM_CALL(CLEARLCD)
 call FILL_TEXT_MEM_SPACE
 LD HL,0
 LD (CURSOR_POS),HL
 LD HL,apropos_ch
 ROM_CALL(D_ZT_STR)
 LD HL,$0007
 LD (CURSOR_POS),HL
 CALL attend_aucune_touche
 ROM_CALL(BUSY_ON) ;remet l'indicateur en haut  droite de l'cran.
restaure_sp:
 ld sp,$0000
 ret

attend_aucune_touche:
 ROM_CALL(GET_KEY)
 or a
 jr nz,attend_aucune_touche
 ret

attend:
 halt
 LD A,C
 CP 0
 RET Z
 DEC C
 JR attend


#ifdef  SNGFR
COORD_TEXT_1 = $150C
COORD_TEXT_2 = $1D11
COORD_TEXT_3 = $250D
COORD_TEXT_4 = $2D1D
COORD_TEXT_5 = $3521

COORD_TRI_11 = $0816
COORD_TRI_12 = $0D1E
COORD_TRI_13 = $0926
COORD_TRI_14 = $192E
COORD_TRI_15 = $1D36
COORD_TRI_21 = $4F16
COORD_TRI_22 = $491E
COORD_TRI_23 = $4D26
COORD_TRI_24 = $3C2E
COORD_TRI_25 = $3836
pasimpl .DB "Pas encore      implemente.",0
apropos_ch .DB "    SNG v0.72         "
           .DB "par        Marc Plouhinec",0
apropos_ch2 .DB "http://thebestof.vze.com",0
pas_prog .DB "Aucun programme",0
ch_pas_edit_hex .DB "Veuillez envoyer"
				.DB "  le programme  "
				.DB "    SNGedit",0

ch_pas_debug    .DB "Veuillez envoyer"
				.DB "  le programme  "
				.DB "    SNGdeb",0

listprog .DB "Liste des programmes",0
listvar  .DB "Liste des variables",0
edithexa .DB "Editeur hexadecimal",0
debug    .DB "Debuggeur",0
apropos  .DB "A propos",0

#else
COORD_TEXT_1 = $1518
COORD_TEXT_2 = $1D22
COORD_TEXT_3 = $250F
COORD_TEXT_4 = $2D20
COORD_TEXT_5 = $3526

COORD_TRI_11 = $1416
COORD_TRI_12 = $1E1E
COORD_TRI_13 = $0B26
COORD_TRI_14 = $1C2E
COORD_TRI_15 = $2236
COORD_TRI_21 = $4016
COORD_TRI_22 = $381E
COORD_TRI_23 = $4D26
COORD_TRI_24 = $3B2E
COORD_TRI_25 = $3436
pasimpl .DB "Not implemented yet.",0
apropos_ch .DB "    SNG v0.72         "
           .DB " by        Marc Plouhinec",0
apropos_ch2 .DB "http://thebestof.vze.com",0
pas_prog .DB "No program",0
ch_pas_edit_hex:
 .DB "  Please send   "
 .DB "  the program   "
 .DB "    SNGedit",0

ch_pas_debug:
 .DB "  Please send   "
 .DB "  the program   "
 .DB "    SNGdeb",0


listprog .DB "Programs list",0
listvar  .DB "Vars list",0
edithexa .DB "Hexadecimal   editor",0
debug    .DB "Debugger",0
apropos  .DB "About",0
#endif

sng_img:
	.db 0,0,0,3,240,120,112,63,0,0,0,0
	.db 0,0,0,7,252,120,112,255,192,0,0,0
	.db 0,0,0,15,252,124,113,255,192,0,0,0
	.db 0,0,0,14,30,124,113,225,224,0,0,0
	.db 0,0,0,14,14,126,115,192,192,0,0,0
	.db 0,0,0,15,128,118,115,128,0,0,0,0
	.db 0,0,0,7,240,119,115,128,0,0,0,0
	.db 0,0,0,3,252,115,115,135,224,0,0,0
	.db 0,0,0,0,62,115,243,135,224,0,0,0
	.db 0,0,0,14,14,113,243,199,224,0,0,0
	.db 0,0,0,15,14,113,241,224,224,0,0,0
	.db 0,0,0,7,254,112,241,255,224,0,0,0
	.db 0,0,0,7,252,112,240,255,192,0,0,0
	.db 0,0,0,1,248,112,112,63,0,0,0,0

sprite_triangle1:
 	.db %10000000
	.db %11000000
	.db %11100000
	.db %11000000
	.db %10000000
 	.db %00000000
	.db %00000000
	.db %00000000
 	.db %10000000
	.db %11000000
	.db %11100000
	.db %11000000
	.db %10000000
 	.db %00000000
	.db %00000000
	.db %00000000

sprite_triangle2:
	.db %00000001
	.db %00000011
	.db %00000111
	.db %00000011
	.db %00000001
 	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000001
	.db %00000011
	.db %00000111
	.db %00000011
	.db %00000001
 	.db %00000000
	.db %00000000
	.db %00000000

DEBUT_PROG =  $9DFB ;L o va commencer les autres programmes
DEBUT_PROG2 = $9E00 ;L o va commencer les autres programmes

.END